/***********************************************************************************************************************
 *
 * SolidBlue - open source safe data
 * Copyright (C) 2011-2012 by Tidalwave s.a.s. (http://tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://solidblue.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/solidblue-src
 *
 **********************************************************************************************************************/
package it.tidalwave.actor.swing.action;

import javax.annotation.Nonnull;
import javax.swing.AbstractAction;
import java.awt.event.ActionEvent;
import it.tidalwave.actor.MessageSupport;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public abstract class MessageSendingActionSupport<T> extends AbstractAction
  {
    @Override
    public void actionPerformed (final @Nonnull ActionEvent event) 
      {
        createMessage(null).send();
      }
    
    @Nonnull
    protected MessageSupport createMessage (@Nonnull T arg)
      {
        return createMessage();
      }
   
    @Nonnull
    protected MessageSupport createMessage()
      {
        throw new UnsupportedOperationException();
      }
  }
