/***********************************************************************************************************************
 *
 * SolidBlue - open source safe data
 * Copyright (C) 2011-2012 by Tidalwave s.a.s. (http://tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://solidblue.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/solidblue-src
 *
 **********************************************************************************************************************/
package it.tidalwave.swing;

import javax.annotation.Nonnull;
import java.util.List;
import it.tidalwave.swing.impl.ReflectionUtils;
import static it.tidalwave.swing.SwingSafeComponentBuilder.*;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public abstract class SwingPresentationBuilder<T extends I, I> 
  {
    @Nonnull
    private final SwingSafeComponentBuilder<T, I> builder;

    public SwingPresentationBuilder()
      {
        final List<Class<?>> t = ReflectionUtils.getTypeArguments(SwingPresentationBuilder.class, getClass());
        builder = builderFor((Class<T>)t.get(0), (Class<I>)t.get(1));
      }    
    
    @Nonnull
    public final synchronized T get() 
      {
        return builder.getInstance();
      }
  }
